\ Build DBFCONST from dBase II header
\ Using: DBFHEAD ufn[.dbf]

decimal
include appstr

: BUFF        ( -- adr )
  here 256 +
;

0 value FID
variable DBFOFF                         \ offset from record begin
  1 dbfoff !                            \ first byte is deletion mark

: FILE-CHECK  ( ior -- )
  abort" File access error"
;

\ Append space
: APPBL       ( -- )
  bl appc
;

\ Write CONSTANT with record size
: WRITE-SIZE  ( -- )
  <pad
  buff 6 + @ appn appbl
  s" CONSTANT RECSIZE" apps
  fid write-line file-check
;

\ Write 2CONSTANT with field size and offset
: WRITE-FIELD ( adr -- adr )
  >r                                    \ save address
  <pad
  r@ 12 + c@ dup >r appn appbl          \ length
  dbfoff @ appn appbl                   \ offset
  r> dbfoff +!                          \ update offset
  s" 2CONSTANT " apps
  r@ 11 0 trim apps                     \ name
  appbl [char] \ appc appbl             \ comment with field type
  r@ 11 + c@ dup >r appc
  r> [char] N = if
    r@ 15 + c@ ?dup if appn then
  then
  fid write-line file-check
  r>                                    \ restore address
;

\ Build complete filename
: FNAME       ( -- addr c )
  cmdtail s" DBF" +ext
;

\ Write comment with filename
: WRITE-FNAME ( -- )
  <pad
  [char] \ appc appbl fname apps
  fid write-line file-check
;

\ Load DBF header (first 521 bytes)
: LOADHEAD    ( -- )
  fname
  r/o open-file file-check to fid
  buff 521 fid read-file file-check drop
  fid close-file file-check
;

: MAIN        ( -- )
  loadhead
  s" DBFCONST.F" w/o create-file file-check to fid
  write-fname
  write-size
  buff 8 +
  begin
    dup c@ $0d <>
  while
    write-field
    16 +
  repeat   drop
  fid close-file file-check
;
